<?php

class Admin_Widgets extends WP_Widget {
    function __construct() {
        global $smp;
        global $custom_post_type;
        parent::__construct('smugmug-widget-images', 'SmugMug Widget', array('description' => 'Display a set number of random images from a SmugMug album.'));
        $this->smugmug = $smp;
        $this->custom_post_type = $custom_post_type;
    }
    public function renderer($layout=false,$type = false,$args = false) {
        $this->class = get_class();
        $this->smugmug->render($layout,$this->class,$type,$args);
    }
    /** @see WP_Widget::widget */
    function widget($args, $instance) {
        
        $args_instance['instance'] = $instance;
        $args_instance['args'] = $args;
        $args_instance['title'] = apply_filters('widget_title', $instance['title']);
        $this->renderer($instance['template'],'widget',$args_instance);
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {
	$instance = $old_instance;
	$instance['title'] = strip_tags($new_instance['title']);
        $instance['album'] = strip_tags($new_instance['album']);
        $instance['template'] = strip_tags($new_instance['template']);
        $instance['image_number'] = strip_tags($new_instance['image_number']);
        return $instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {
        $albums = $this->smugmug->phpsmug_functions('albums_get');
        $templates = $this->custom_post_type->get_smp_templates(TEMPLATE_DIR,'widget','SmugMug Widget Template');
        $seleted_template = esc_attr($instance['template']);
        $title = esc_attr($instance['title']);
        $album = esc_attr($instance['album']);
        $image_number = esc_attr($instance['image_number']);
        ?>
         <p>
          <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
        </p>
        <p>
          <?php //print_r($instance); ?>
          <label for="<?php echo $this->get_field_id('album'); ?>"><?php _e('Album:'); ?></label> 
          <select class="widefat" id="<?php echo $this->get_field_id('album'); ?>" name="<?php echo $this->get_field_name('album'); ?>" type="text">
              <option value="">Select Album</option>
              <?php foreach($albums as $album_new):
                  $album_id_key = $album_new['id'] .'|'.$album_new['Key'];
                  ?>
                <option value="<?php echo $album_id_key; ?>" <?php echo ($album_id_key == $album) ? 'selected="selected"' : ''; ?>><?php echo $album_new['Title']; ?></option>
              <?php endforeach; ?>
          </select>
        </p>
        <p>
          <?php //print_r($instance); ?>
          <label for="<?php echo $this->get_field_id('template'); ?>"><?php _e('Template:'); ?></label> 
          <select class="widefat" id="<?php echo $this->get_field_id('template'); ?>" name="<?php echo $this->get_field_name('template'); ?>" type="text">
              <option value="default">Select Template</option>
              <?php foreach($templates as $template): ?>
                <option value="<?php echo $template['value']; ?>" <?php echo ($template['value'] == $seleted_template) ? 'selected="selected"' : ''; ?>><?php echo $template['name']; ?></option>
              <?php endforeach; ?>
          </select>
        </p>
        <p>
          <label for="<?php echo $this->get_field_id('image_number'); ?>"><?php _e('Number of Images:'); ?></label> 
          <input class="widefat" id="<?php echo $this->get_field_id('image_number'); ?>" name="<?php echo $this->get_field_name('image_number'); ?>" type="text" value="<?php echo $image_number; ?>" />
          <span class="description">The Number of Images to Display</span>
        </p>
        <?php 
    }
}
